## spfft 0.9.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.8 added CUDA language support without FindCUDA
project(SpFFT LANGUAGES CXX VERSION 0.9.9)

# allow {module}_ROOT variables to be set
if(POLICY CMP0074)
	cmake_policy(SET CMP0074 NEW)
endif()

# use INTERFACE_LINK_LIBRARIES property if available
if(POLICY CMP0022)
	cmake_policy(SET CMP0022 NEW)
endif()

# set default build type to RELEASE
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type" FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
		"Debug" "Release" "MinSizeRel" "RelWithDebInfo"
		)
endif()

# set language and standard
set(CMAKE_CXX_STANDARD 11)

#add local module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/modules)

# Options
option(SPFFT_STATIC "Compile as static library" OFF)
option(SPFFT_OMP "Compile with OpenMP support" ON)
option(SPFFT_MPI "Compile with MPI support" ON)
option(SPFFT_GPU_DIRECT "Compile with GPU direct (GPU aware MPI) support." OFF)
option(SPFFT_BUILD_TESTS "Build tests" OFF)
option(SPFFT_SINGLE_PRECISION "Enable single precision support" OFF)
option(SPFFT_INSTALL "Enable CMake install commands" ON)

set(SPFFT_GPU_BACKEND "OFF" CACHE STRING "GPU backend")
set_property(CACHE SPFFT_GPU_BACKEND PROPERTY STRINGS
	"OFF" "CUDA" "ROCM"
	)

# set preferred library type
if (SPFFT_STATIC)
	# prefer static over dynamic libraries with the find_library() command by changing the order
	set(CMAKE_FIND_LIBRARY_SUFFIXES_SAVE ${CMAKE_FIND_LIBRARY_SUFFIXES})
	if(APPLE)
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .tbd .dylib .so)
	elseif(UNIX)
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .so)
	endif()
	set(SPFFT_LIBRARY_TYPE STATIC)
else()
	set(SPFFT_LIBRARY_TYPE SHARED)
endif()

set(SPFFT_DEFINITIONS)
set(SPFFT_EXTERNAL_COMPILE_OPTIONS)
set(SPFFT_LIBS)
set(SPFFT_EXTERNAL_LIBS)
set(SPFFT_INTERFACE_LIBS)
set(SPFFT_INTERFACE_INCLUDE_DIRS)
set(SPFFT_INCLUDE_DIRS)
set(SPFFT_EXTERNAL_INCLUDE_DIRS)
set(SPFFT_EXTERNAL_PKG_PACKAGES)

# Options combination check
set(SPFFT_CUDA OFF)
set(SPFFT_ROCM OFF)
if(SPFFT_GPU_BACKEND)
	if(SPFFT_GPU_BACKEND STREQUAL "CUDA")
		set(SPFFT_CUDA ON)
	elseif(SPFFT_GPU_BACKEND STREQUAL "ROCM")
		set(SPFFT_ROCM ON)
	else()
		message(FATAL_ERROR "Invalid GPU backend option")
	endif()
endif()
mark_as_advanced(SPFFT_CUDA SPFFT_ROCM)

# Hide symbols by default if tests are not build
if(NOT SPFFT_BUILD_TESTS)
	set(CMAKE_CXX_VISIBILITY_PRESET hidden)
	set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
else()
	# disable visibility macros if tests are build
	list(APPEND SPFFT_DEFINITIONS -DSPFFT_STATIC_DEFINE)
	set(CMAKE_CXX_VISIBILITY_PRESET default)
	set(CMAKE_VISIBILITY_INLINES_HIDDEN 0)
endif()

# CUDA
if(SPFFT_CUDA)
	enable_language(CUDA)
	find_library(CUDA_CUDART_LIBRARY cudart PATHS ${CMAKE_CUDA_IMPLICIT_LINK_DIRECTORIES})
	find_library(CUDA_CUFFT_LIBRARY cufft PATHS ${CMAKE_CUDA_IMPLICIT_LINK_DIRECTORIES})
	list(APPEND SPFFT_EXTERNAL_LIBS ${CUDA_CUDART_LIBRARY} ${CUDA_CUFFT_LIBRARY})
	list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})
endif()

# ROCM
if(SPFFT_ROCM)
	find_package(ROCM REQUIRED COMPONENTS rocfft)
	list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${ROCM_INCLUDE_DIRS})
	list(APPEND SPFFT_EXTERNAL_LIBS ${ROCM_LIBRARIES})
	list(APPEND SPFFT_EXTERNAL_COMPILE_OPTIONS ${ROCM_DEFINITIONS})
endif()


if(SPFFT_MPI)
	find_package(MPI REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS MPI::MPI_CXX)
	# always add MPI to interface libraries, because mpi.h is included in public header files
	if(SPFFT_STATIC)
		list(APPEND SPFFT_INTERFACE_LIBS ${MPI_CXX_LIBRARIES})
	endif()
	list(APPEND SPFFT_INTERFACE_INCLUDE_DIRS ${MPI_CXX_INCLUDE_DIRS})
endif()

if(SPFFT_OMP)
	find_package(OpenMP REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS OpenMP::OpenMP_CXX)
	if(SPFFT_STATIC)
		list(APPEND SPFFT_INTERFACE_LIBS ${OpenMP_CXX_LIBRARIES})
	endif()
endif()

if(SPFFT_GPU_DIRECT)
	message(STATUS "GPU Direct support enabled: Additional environment variables might have to be set before execution. (e.g \"export MPICH_RDMA_ENABLED_CUDA=1\")")
endif()



# Use MKL if available, otherwise require FFTW3
if(UNIX AND NOT APPLE)
	# prefer static MKL in Linux. Together with "-Wl,--exclude-libs,ALL",
	# symbols are not visible for linking afterwards and no conflicts with other MKL versions of other libraries should exist.
	set(_TMP_SAVE ${CMAKE_FIND_LIBRARY_SUFFIXES})
	set(CMAKE_FIND_LIBRARY_SUFFIXES .a .so)
endif()
find_package(MKLSequential)
if(UNIX AND NOT APPLE)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ${_TMP_SAVE})
	unset(_TMP_SAVE)
endif()

if(MKLSequential_FOUND)
	list(APPEND SPFFT_EXTERNAL_LIBS MKL::Sequential)
	if(SPFFT_STATIC)
		list(APPEND SPFFT_INTERFACE_LIBS ${MKLSequential_LIBRARIES})
	endif()
	list(APPEND SPFFT_EXTERNAL_PKG_PACKAGES mkl-dynamic-lp64-seq)
else()
	find_package(FFTW REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS FFTW::FFTW)
	if(SPFFT_STATIC)
		list(APPEND SPFFT_INTERFACE_LIBS ${FFTW_LIBRARIES})
	endif()
	if(SPFFT_SINGLE_PRECISION AND NOT FFTW_FLOAT_FOUND)
		message(FATAL_ERROR "FFTW library with single precision support NOT FOUND. Disable SPFFT_SINGLE_PRECISION or provide path to library.")
	endif()
	list(APPEND SPFFT_EXTERNAL_PKG_PACKAGES fftw3)
endif()


if(SPFFT_BUILD_TESTS)
	# enable timing with testing
	set(SPFFT_TIMING ON)
endif()

# generate config.h
configure_file(include/spfft/config.h.in ${PROJECT_BINARY_DIR}/spfft/config.h)

list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src)
list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/include)
list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_BINARY_DIR})
list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/ext)

#############################################################################
# All include dirs and definitions must be set before sub-directory is added!
#############################################################################
add_subdirectory(src)

list(APPEND SPFFT_LIBS spfft)

# add tests for developement
if(SPFFT_BUILD_TESTS)
	add_subdirectory(tests)
endif()

# reset cmake library suffixes
if(SPFFT_STATIC)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_FIND_LIBRARY_SUFFIXES_SAVE})
endif()

=== src/CMakeLists.txt ===
set(SPFFT_SOURCE_FILES
	memory/aligned_allocation.cpp
	timing/timing.cpp
	timing/rt_graph.cpp
	parameters/parameters.cpp
	execution/execution_host.cpp
	spfft/transform.cpp
	spfft/transform_internal.cpp
	spfft/multi_transform.cpp
	spfft/grid.cpp
	spfft/grid_internal.cpp
	)

if(SPFFT_SINGLE_PRECISION)
	list(APPEND SPFFT_SOURCE_FILES
		spfft/transform_float.cpp
		spfft/multi_transform_float.cpp
		spfft/grid_float.cpp
		)
endif()

set(SPFFT_GPU_KERNELS)
if(SPFFT_CUDA OR SPFFT_ROCM)
	list(APPEND SPFFT_GPU_KERNELS
		transpose/gpu_kernels/local_transpose_kernels.cu
		compression/gpu_kernels/compression_kernels.cu
		symmetry/gpu_kernels/symmetry_kernels.cu
		transpose/gpu_kernels/buffered_kernels.cu
		transpose/gpu_kernels/compact_buffered_kernels.cu
		)
	list(APPEND SPFFT_SOURCE_FILES
		execution/execution_gpu.cpp
		gpu_util/gpu_fft_api.cpp
		)
	if(SPFFT_MPI)
		list(APPEND SPFFT_SOURCE_FILES
			transpose/transpose_mpi_buffered_gpu.cpp
			transpose/transpose_mpi_compact_buffered_gpu.cpp
			transpose/transpose_mpi_unbuffered_gpu.cpp
			)
	endif()
endif()

if(SPFFT_CUDA)
	list(APPEND SPFFT_SOURCE_FILES ${SPFFT_GPU_KERNELS})
endif()

if(SPFFT_ROCM)
	rocm_generate_objects(ROCM_OBJECTS ROCM_TARGETS ${SPFFT_GPU_KERNELS} INCLUDE_DIRS ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS}
		FLAGS -fPIC  -fno-gpu-rdc --amdgpu-target=gfx803 --amdgpu-target=gfx900 --amdgpu-target=gfx906)
	list(APPEND SPFFT_SOURCE_FILES ${ROCM_OBJECTS})
endif()

if(SPFFT_MPI)
	list(APPEND SPFFT_SOURCE_FILES
		transpose/transpose_mpi_buffered_host.cpp
		transpose/transpose_mpi_compact_buffered_host.cpp
		transpose/transpose_mpi_unbuffered_host.cpp
		)
endif()

add_library(spfft ${SPFFT_LIBRARY_TYPE}
	${SPFFT_SOURCE_FILES}
	)

# Don't export any symbols of external static libaries. Only works on linux.
if(UNIX AND NOT APPLE)
	if(${CMAKE_VERSION} VERSION_LESS "3.13.5") 
		set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--exclude-libs,ALL")
	else()
		target_link_options(spfft PRIVATE "-Wl,--exclude-libs,ALL")
	endif()
endif()

# add depency on ojbect generating targets for ROCM
if(SPFFT_ROCM)
	add_dependencies(spfft ${ROCM_TARGETS})
endif()

# generate export header to control symbol visibility
include(GenerateExportHeader)
generate_export_header(spfft)
configure_file("${CMAKE_CURRENT_BINARY_DIR}/spfft_export.h"
	"${PROJECT_BINARY_DIR}/spfft/spfft_export.h"
	COPYONLY
)

target_compile_options(spfft PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
target_include_directories(spfft PRIVATE ${SPFFT_EXTERNAL_INCLUDE_DIRS})
target_include_directories(spfft PRIVATE ${PROJECT_SOURCE_DIR}/include)
target_include_directories(spfft PRIVATE ${PROJECT_SOURCE_DIR}/src)
target_include_directories(spfft PRIVATE ${PROJECT_BINARY_DIR})
target_link_libraries(spfft PRIVATE ${SPFFT_EXTERNAL_LIBS})

target_include_directories(spfft INTERFACE ${SPFFT_INTERFACE_INCLUDE_DIRS})
target_include_directories(spfft INTERFACE $<INSTALL_INTERFACE:include>) # for install(EXPORT ...)
target_include_directories(spfft INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>) # for export(...)

# set list of interface libries for exporting (workaround for bug with exporting static library:
# cmake uses MPI_CXX and OpenMP::OpenMP_CXX targets, which are not known externally)
if(POLICY CMP0022)
	set_target_properties(spfft PROPERTIES INTERFACE_LINK_LIBRARIES "${SPFFT_INTERFACE_LIBS}")
else()
	set_target_properties(spfft PROPERTIES LINK_INTERFACE_LIBRARIES "${SPFFT_INTERFACE_LIBS}")
endif()

# set packge config names
if(SPFFT_STATIC)
	set(SPFFT_VERSION_FILE "SpFFTStaticConfigVersion.cmake")
	set(SPFFT_CONFIG_FILE "SpFFTStaticConfig.cmake")
	set(SPFFT_TARGETS_FILE "SpFFTStaticTargets.cmake")
else()
	set(SPFFT_VERSION_FILE "SpFFTSharedConfigVersion.cmake")
	set(SPFFT_CONFIG_FILE "SpFFTSharedConfig.cmake")
	set(SPFFT_TARGETS_FILE "SpFFTSharedTargets.cmake")
endif()


# generate cmake package
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
	"${PROJECT_BINARY_DIR}/${SPFFT_VERSION_FILE}"
	VERSION ${Upstream_VERSION}
	COMPATIBILITY AnyNewerVersion
)
export(TARGETS spfft NAMESPACE SpFFT:: FILE ${PROJECT_BINARY_DIR}/${SPFFT_TARGETS_FILE})
configure_file(${PROJECT_SOURCE_DIR}/cmake/${SPFFT_CONFIG_FILE}
	"${PROJECT_BINARY_DIR}/${SPFFT_CONFIG_FILE}"
	@ONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFTConfig.cmake
	"${PROJECT_BINARY_DIR}/SpFFTConfig.cmake"
	COPYONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFTConfigVersion.cmake
	"${PROJECT_BINARY_DIR}/SpFFTConfigVersion.cmake"
	COPYONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFTTargets.cmake
	"${PROJECT_BINARY_DIR}/SpFFTTargets.cmake"
	COPYONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFT.pc.in
	"${PROJECT_BINARY_DIR}/SpFFT.pc"
	@ONLY
)

# installation commands
if(SPFFT_INSTALL)
	install(TARGETS spfft DESTINATION lib EXPORT SpFFTTargets)
	install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/spfft DESTINATION include FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp" PATTERN "*.f90")
	install(FILES ${PROJECT_BINARY_DIR}/spfft/config.h "${PROJECT_BINARY_DIR}/spfft/spfft_export.h" DESTINATION include/spfft)
	install(EXPORT SpFFTTargets NAMESPACE SpFFT:: DESTINATION lib/cmake/SpFFT FILE ${SPFFT_TARGETS_FILE})
	install(
	  FILES
		"${PROJECT_BINARY_DIR}/SpFFTConfig.cmake"
		"${PROJECT_BINARY_DIR}/SpFFTTargets.cmake"
		"${PROJECT_BINARY_DIR}/SpFFTConfigVersion.cmake"
		"${PROJECT_BINARY_DIR}/${SPFFT_CONFIG_FILE}"
		"${PROJECT_BINARY_DIR}/${SPFFT_VERSION_FILE}"
	  DESTINATION
	  lib/cmake/SpFFT
	)
	install(FILES ${PROJECT_BINARY_DIR}/SpFFT.pc DESTINATION lib/pkgconfig)
endif()

=== debian/changelog ===
spfft (0.9.9-1) unstable; urgency=medium

  * Initial release (Closes: #945813)

 -- Andrius Merkys <merkys@debian.org>  Thu, 28 Nov 2019 04:54:07 -0500

=== debian/control ===
Source: spfft
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libfftw3-dev,
 mpi-default-dev,
Standards-Version: 4.4.1
Homepage: https://github.com/eth-cscs/SpFFT
Vcs-Browser: https://salsa.debian.org/science-team/spfft
Vcs-Git: https://salsa.debian.org/science-team/spfft.git

Package: libspfft-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libspfft0 (= ${binary:Version}),
 ${misc:Depends},
Description: Sparse 3D FFT library with MPI, OpenMP, CUDA / ROCm support (development files)
 SpFFT was originally intended for transforms of data with spherical cutoff in
 frequency domain, as required by some computational material science codes.
 For distributed computations, SpFFT uses a slab decomposition in space domain
 and pencil decomposition in frequency domain (all sparse data within a pencil
 must be on one rank). If desired, the libray can be compiled without any
 parallelization (MPI, OpenMP, CUDA / ROCm).
 .
 This package contains development files.

Package: libspfft0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Sparse 3D FFT library with MPI, OpenMP, CUDA / ROCm support
 SpFFT was originally intended for transforms of data with spherical cutoff in
 frequency domain, as required by some computational material science codes.
 For distributed computations, SpFFT uses a slab decomposition in space domain
 and pencil decomposition in frequency domain (all sparse data within a pencil
 must be on one rank). If desired, the libray can be compiled without any
 parallelization (MPI, OpenMP, CUDA / ROCm).

## spfft 0.9.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,7 @@
-cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.8 added CUDA language support without FindCUDA
-project(SpFFT LANGUAGES CXX VERSION 0.9.9)
+cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.11 to avoid issues with OpenMP + CUDA
+project(SpFFT LANGUAGES CXX VERSION 0.9.10)
+set(SPFFT_SO_VERSION 0)
+set(SPFFT_VERSION ${PROJECT_VERSION})
 
 # allow {module}_ROOT variables to be set
 if(POLICY CMP0074)
@@ -33,11 +35,15 @@
 option(SPFFT_BUILD_TESTS "Build tests" OFF)
 option(SPFFT_SINGLE_PRECISION "Enable single precision support" OFF)
 option(SPFFT_INSTALL "Enable CMake install commands" ON)
+option(SPFFT_FORTRAN "Compile fortran module" OFF)
 
 set(SPFFT_GPU_BACKEND "OFF" CACHE STRING "GPU backend")
 set_property(CACHE SPFFT_GPU_BACKEND PROPERTY STRINGS
 	"OFF" "CUDA" "ROCM"
 	)
+
+# Get GNU standard install prefixes
+include(GNUInstallDirs)
 
 # set preferred library type
 if (SPFFT_STATIC)
@@ -88,6 +94,11 @@
 	set(CMAKE_VISIBILITY_INLINES_HIDDEN 0)
 endif()
 
+# Fortran
+if(SPFFT_FORTRAN)
+	enable_language(Fortran)
+endif()
+
 # CUDA
 if(SPFFT_CUDA)
 	enable_language(CUDA)
@@ -107,7 +118,7 @@
 
 
 if(SPFFT_MPI)
-	find_package(MPI REQUIRED)
+	find_package(MPI COMPONENTS CXX REQUIRED)
 	list(APPEND SPFFT_EXTERNAL_LIBS MPI::MPI_CXX)
 	# always add MPI to interface libraries, because mpi.h is included in public header files
 	if(SPFFT_STATIC)
@@ -117,7 +128,7 @@
 endif()
 
 if(SPFFT_OMP)
-	find_package(OpenMP REQUIRED)
+	find_package(OpenMP COMPONENTS CXX REQUIRED)
 	list(APPEND SPFFT_EXTERNAL_LIBS OpenMP::OpenMP_CXX)
 	if(SPFFT_STATIC)
 		list(APPEND SPFFT_INTERFACE_LIBS ${OpenMP_CXX_LIBRARIES})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -62,6 +62,13 @@
 add_library(spfft ${SPFFT_LIBRARY_TYPE}
 	${SPFFT_SOURCE_FILES}
 	)
+set_property(TARGET spfft PROPERTY VERSION ${SPFFT_VERSION})
+set_property(TARGET spfft PROPERTY SOVERSION ${SPFFT_SO_VERSION})
+
+# build fortran module
+if(SPFFT_FORTRAN)
+	add_library(spfft_fortran OBJECT ${PROJECT_SOURCE_DIR}/include/spfft/spfft.f90)
+endif()
 
 # Don't export any symbols of external static libaries. Only works on linux.
 if(UNIX AND NOT APPLE)
@@ -147,10 +154,10 @@
 
 # installation commands
 if(SPFFT_INSTALL)
-	install(TARGETS spfft DESTINATION lib EXPORT SpFFTTargets)
-	install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/spfft DESTINATION include FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp" PATTERN "*.f90")
-	install(FILES ${PROJECT_BINARY_DIR}/spfft/config.h "${PROJECT_BINARY_DIR}/spfft/spfft_export.h" DESTINATION include/spfft)
-	install(EXPORT SpFFTTargets NAMESPACE SpFFT:: DESTINATION lib/cmake/SpFFT FILE ${SPFFT_TARGETS_FILE})
+	install(TARGETS spfft DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT SpFFTTargets)
+	install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/spfft DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp" PATTERN "*.f90")
+	install(FILES ${PROJECT_BINARY_DIR}/spfft/config.h "${PROJECT_BINARY_DIR}/spfft/spfft_export.h" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/spfft)
+	install(EXPORT SpFFTTargets NAMESPACE SpFFT:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/SpFFT FILE ${SPFFT_TARGETS_FILE})
 	install(
 	  FILES
 		"${PROJECT_BINARY_DIR}/SpFFTConfig.cmake"
@@ -159,7 +166,12 @@
 		"${PROJECT_BINARY_DIR}/${SPFFT_CONFIG_FILE}"
 		"${PROJECT_BINARY_DIR}/${SPFFT_VERSION_FILE}"
 	  DESTINATION
-	  lib/cmake/SpFFT
+	    ${CMAKE_INSTALL_LIBDIR}/cmake/SpFFT
 	)
-	install(FILES ${PROJECT_BINARY_DIR}/SpFFT.pc DESTINATION lib/pkgconfig)
+
+	install(FILES ${PROJECT_BINARY_DIR}/SpFFT.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+
+	if(SPFFT_FORTRAN)
+		install(FILES ${PROJECT_BINARY_DIR}/src/spfft.mod DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/spfft)
+	endif()
 endif()

=== tests/CMakeLists.txt ===

if(SPFFT_BUILD_TESTS)
	cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # git fetch module requires at least 3.11
	set(BUILD_GMOCK OFF CACHE BOOL "")
	set(INSTALL_GTEST OFF CACHE BOOL "")
	mark_as_advanced(BUILD_GMOCK INSTALL_GTEST)
	include(FetchContent)

	# add googletest
	FetchContent_Declare(
	  googletest
	  GIT_REPOSITORY https://github.com/google/googletest.git
	  GIT_TAG        release-1.8.1
	)
	FetchContent_GetProperties(googletest)
	if(NOT googletest_POPULATED)
	  message(STATUS "Downloading Google Test repository...")
	  FetchContent_Populate(googletest)
	endif()
	add_subdirectory(${googletest_SOURCE_DIR} ${googletest_BINARY_DIR})

	# add gtest_mpi
	FetchContent_Declare(
	  gtest_mpi
	  GIT_REPOSITORY https://github.com/AdhocMan/gtest_mpi.git
	  GIT_TAG        v1.0.0
	)
	FetchContent_GetProperties(gtest_mpi)
	if(NOT gtest_mpi_POPULATED)
	  message(STATUS "Downloading Google Test MPI extension repository...")
	  FetchContent_Populate(gtest_mpi)
	endif()
	add_subdirectory(${gtest_mpi_SOURCE_DIR} ${gtest_mpi_BINARY_DIR})

	# add command line parser
	FetchContent_Declare(
	  cli11
	  GIT_REPOSITORY https://github.com/CLIUtils/CLI11.git
	  GIT_TAG        v1.7.1
	)
	FetchContent_GetProperties(cli11)
	if(NOT cli11_POPULATED)
	  message(STATUS "Downloading CLI11 command line parser repository...")
	  FetchContent_Populate(cli11)
	endif()
	list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${cli11_SOURCE_DIR}/include)

	# add json parser
	set(JSON_Install OFF CACHE BOOL "")
	FetchContent_Declare(
	  json
	  GIT_REPOSITORY https://github.com/nlohmann/json.git
	  GIT_TAG        v3.6.1
	)
	FetchContent_GetProperties(json)
	if(NOT json_POPULATED)
	  message(STATUS "Downloading json repository...")
	  FetchContent_Populate(json)
	endif()
	set(JSON_BuildTests OFF CACHE INTERNAL "")
	add_subdirectory(${json_SOURCE_DIR} ${json_BINARY_DIR})
	list(APPEND SPFFT_EXTERNAL_LIBS nlohmann_json::nlohmann_json)


	list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/tests)

	# benchmark executable
	add_executable(benchmark programs/benchmark.cpp)
	target_link_libraries(benchmark PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
	target_compile_options(benchmark PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
	target_include_directories(benchmark PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})

	# if(SPFFT_CUDA)
	#     set_property(TARGET main PROPERTY CUDA_SEPARABLE_COMPILATION ON)
	# endif()

	# test executables
	add_executable(run_local_tests
		run_local_tests.cpp
		local_tests/test_host_array.cpp
		local_tests/test_disjoint.cpp
		local_tests/test_local_transform.cpp
		)
	target_link_libraries(run_local_tests PRIVATE gtest_main gtest_mpi)
	target_link_libraries(run_local_tests PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
	target_compile_options(run_local_tests PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
	target_include_directories(run_local_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})

	if(SPFFT_MPI)
		add_executable(run_mpi_tests
			run_mpi_tests.cpp
			mpi_tests/test_transform.cpp
			mpi_tests/test_multi_transform.cpp
			mpi_tests/test_transpose.cpp
			mpi_tests/test_transpose_gpu.cpp
			)
		target_link_libraries(run_mpi_tests PRIVATE gtest_main gtest_mpi)
		target_link_libraries(run_mpi_tests PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
		target_compile_options(run_mpi_tests PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
		target_include_directories(run_mpi_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
	endif()

endif()

=== debian/changelog ===
spfft (0.9.10-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:26:07 +0100

spfft (0.9.10-1) unstable; urgency=medium

  * New upstream version 0.9.10
  * Removing upstream-integrated patch.
  * Adding 'Rules-Requires-Root: no'.

 -- Andrius Merkys <merkys@debian.org>  Fri, 27 Dec 2019 01:16:10 -0500

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
  libfftw3-dev,
  mpi-default-dev,
 Standards-Version: 4.4.1
+Rules-Requires-Root: no
 Homepage: https://github.com/eth-cscs/SpFFT
 Vcs-Browser: https://salsa.debian.org/science-team/spfft
 Vcs-Git: https://salsa.debian.org/science-team/spfft.git

## spfft 0.9.11

=== debian/changelog ===
spfft (0.9.11-1) unstable; urgency=medium

  * New upstream version 0.9.11
  * Refreshing remove-badges.patch.
  * Fixing a typo in package description.

 -- Andrius Merkys <merkys@debian.org>  Tue, 30 Jun 2020 01:09:29 -0400

## spfft 0.9.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.11 to avoid issues with OpenMP + CUDA
-project(SpFFT LANGUAGES CXX VERSION 0.9.10)
+project(SpFFT LANGUAGES CXX VERSION 0.9.12)
 set(SPFFT_SO_VERSION 0)
 set(SPFFT_VERSION ${PROJECT_VERSION})
 
@@ -110,10 +110,15 @@
 
 # ROCM
 if(SPFFT_ROCM)
-	find_package(ROCM REQUIRED COMPONENTS rocfft)
-	list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${ROCM_INCLUDE_DIRS})
-	list(APPEND SPFFT_EXTERNAL_LIBS ${ROCM_LIBRARIES})
-	list(APPEND SPFFT_EXTERNAL_COMPILE_OPTIONS ${ROCM_DEFINITIONS})
+	if(NOT HIP_HCC_FLAGS)
+		message(STATUS "Using default AMD gpu targets: gfx803, gfx900, gfx906. Set HIP_HCC_FLAGS to override.")
+		set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} --amdgpu-target=gfx803 --amdgpu-target=gfx900 --amdgpu-target=gfx906)
+	endif()
+	find_package(HIP REQUIRED)
+	find_package(HIPLIBS REQUIRED)
+	find_package(ROCFFT REQUIRED)
+	list(APPEND SPFFT_EXTERNAL_LIBS HIPLIBS::hiplibs ROCFFT::rocfft)
+	list(APPEND SPFFT_EXTERNAL_COMPILE_OPTIONS -D__HIP_PLATFORM_HCC__) # required for parsing HIP headers with another compiler
 endif()

=== debian/changelog ===
spfft (0.9.12-1) unstable; urgency=medium

  * New upstream version 0.9.12
  * Updating copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 03 Aug 2020 03:13:30 -0400

## spfft 0.9.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.11 to avoid issues with OpenMP + CUDA
-project(SpFFT LANGUAGES CXX VERSION 0.9.12)
+project(SpFFT LANGUAGES CXX VERSION 0.9.13)
 set(SPFFT_SO_VERSION 0)
 set(SPFFT_VERSION ${PROJECT_VERSION})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
 	spfft/multi_transform.cpp
 	spfft/grid.cpp
 	spfft/grid_internal.cpp
+	fft/fftw_mutex.cpp
 	)
 
 if(SPFFT_SINGLE_PRECISION)
@@ -39,16 +40,7 @@
 			transpose/transpose_mpi_unbuffered_gpu.cpp
 			)
 	endif()
-endif()
-
-if(SPFFT_CUDA)
 	list(APPEND SPFFT_SOURCE_FILES ${SPFFT_GPU_KERNELS})
-endif()
-
-if(SPFFT_ROCM)
-	rocm_generate_objects(ROCM_OBJECTS ROCM_TARGETS ${SPFFT_GPU_KERNELS} INCLUDE_DIRS ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS}
-		FLAGS -fPIC  -fno-gpu-rdc --amdgpu-target=gfx803 --amdgpu-target=gfx900 --amdgpu-target=gfx906)
-	list(APPEND SPFFT_SOURCE_FILES ${ROCM_OBJECTS})
 endif()
 
 if(SPFFT_MPI)
@@ -59,11 +51,26 @@
 		)
 endif()
 
-add_library(spfft ${SPFFT_LIBRARY_TYPE}
-	${SPFFT_SOURCE_FILES}
-	)
+if(SPFFT_ROCM)
+	set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} -fno-gpu-rdc)
+	set(HIP_HCC_FLAGS_RELEASE ${HIP_HCC_FLAGS_RELEASE} -Wno-everything)
+	if(CMAKE_CXX_STANDARD)
+		set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} -std=gnu++${CMAKE_CXX_STANDARD})
+	endif()
+			
+	# macro from FindHIP package, which compiles all .cu files with hipcc and cpp files with the set c++ compiler
+	HIP_ADD_LIBRARY(spfft ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
+else()
+	add_library(spfft ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
+endif()
+
 set_property(TARGET spfft PROPERTY VERSION ${SPFFT_VERSION})
 set_property(TARGET spfft PROPERTY SOVERSION ${SPFFT_SO_VERSION})
+# All .cu files are self-contained. Device linking can have issues with propageted linker flags of other targets like MPI.
+if(SPFFT_CUDA)
+	set_property(TARGET spfft PROPERTY CUDA_RESOLVE_DEVICE_SYMBOLS OFF)
+	set_property(TARGET spfft PROPERTY CUDA_SEPARABLE_COMPILATION OFF)
+endif()
 
 # build fortran module
 if(SPFFT_FORTRAN)
@@ -77,11 +84,6 @@
 	else()
 		target_link_options(spfft PRIVATE "-Wl,--exclude-libs,ALL")
 	endif()
-endif()
-
-# add depency on ojbect generating targets for ROCM
-if(SPFFT_ROCM)
-	add_dependencies(spfft ${ROCM_TARGETS})
 endif()
 
 # generate export header to control symbol visibility

=== debian/changelog ===
spfft (0.9.13-1) unstable; urgency=medium

  * New upstream version 0.9.13

 -- Andrius Merkys <merkys@debian.org>  Mon, 24 Aug 2020 02:36:13 -0400

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
  frequency domain, as required by some computational material science codes.
  For distributed computations, SpFFT uses a slab decomposition in space domain
  and pencil decomposition in frequency domain (all sparse data within a pencil
- must be on one rank). If desired, the libray can be compiled without any
+ must be on one rank). If desired, the library can be compiled without any
  parallelization (MPI, OpenMP, CUDA / ROCm).
  .
  This package contains development files.
@@ -43,5 +43,5 @@
  frequency domain, as required by some computational material science codes.
  For distributed computations, SpFFT uses a slab decomposition in space domain
  and pencil decomposition in frequency domain (all sparse data within a pencil
- must be on one rank). If desired, the libray can be compiled without any
+ must be on one rank). If desired, the library can be compiled without any
  parallelization (MPI, OpenMP, CUDA / ROCm).

## spfft 1.0.4

=== debian/changelog ===
spfft (1.0.4-1) unstable; urgency=medium

  * New upstream version 1.0.4
  * Refreshing remove-badges.patch.

 -- Andrius Merkys <merkys@debian.org>  Mon, 16 Aug 2021 01:58:50 -0400

spfft (1.0.1-1) experimental; urgency=medium

  * New upstream version 1.0.1
  * Removing unneeded debian/ files.
  * Updating copyright years.
  * Bumping debhelper-compat and Standards-Version (no changes).

 -- Andrius Merkys <merkys@debian.org>  Mon, 15 Feb 2021 03:30:39 -0500

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
  Andrius Merkys <merkys@debian.org>,
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libfftw3-dev,
  mpi-default-dev,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/eth-cscs/SpFFT
 Vcs-Browser: https://salsa.debian.org/science-team/spfft
@@ -20,7 +20,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libspfft0 (= ${binary:Version}),
+ libspfft1 (= ${binary:Version}),
  ${misc:Depends},
 Description: Sparse 3D FFT library with MPI, OpenMP, CUDA / ROCm support (development files)
  SpFFT was originally intended for transforms of data with spherical cutoff in
@@ -32,7 +32,7 @@
  .
  This package contains development files.
 
-Package: libspfft0
+Package: libspfft1
 Architecture: any
 Multi-Arch: same
 Depends:

## spfft 1.0.5

=== debian/changelog ===
spfft (1.0.5-1) unstable; urgency=medium

  * New upstream version 1.0.5
  * Adding copyright entry for FindHIP CMake files.

 -- Andrius Merkys <merkys@debian.org>  Fri, 05 Nov 2021 08:22:20 -0400

## spfft 1.0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11 FATAL_ERROR) # 3.11 to avoid issues with OpenMP + CUDA
project(SpFFT LANGUAGES CXX VERSION 1.0.6)
set(SPFFT_SO_VERSION 1)
set(SPFFT_VERSION ${PROJECT_VERSION})

# allow {module}_ROOT variables to be set
if(POLICY CMP0074)
	cmake_policy(SET CMP0074 NEW)
endif()

# Initialize CMAKE_CUDA_ARCHITECTURES through nvcc if possible
if(POLICY CMP0104)
	cmake_policy(SET CMP0104 NEW)
endif()

# set default build type to RELEASE
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type" FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
		"Debug" "Release" "MinSizeRel" "RelWithDebInfo"
		)
endif()

# set language and standard
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CUDA_STANDARD 11)

# set CUDA flags
if(NOT CMAKE_CUDA_FLAGS_RELEASE)
	set(CMAKE_CUDA_FLAGS_RELEASE "-O3 -DNDEBUG" CACHE STRING "Flags used by CUDA compiler at given build type." FORCE)
endif()
if(NOT CMAKE_CUDA_FLAGS_RELWITHDEBINFO)
	set(CMAKE_CUDA_FLAGS_RELWITHDEBINFO "-O2 -g -DNDEBUG" CACHE STRING "Flags used by CUDA compiler at given build type." FORCE)
endif()
if(NOT CMAKE_CUDA_FLAGS_MINSIZEREL)
	set(CMAKE_CUDA_FLAGS_MINSIZEREL "-Os -DNDEBUG" CACHE STRING "Flags used by CUDA compiler at given build type." FORCE)
endif()
if(NOT CMAKE_CUDA_FLAGS_DEBUG)
	set(CMAKE_CUDA_FLAGS_DEBUG "-g" CACHE STRING "Flags used by CUDA compiler at given build type." FORCE)
endif()

#add local module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/modules)

# Options
option(SPFFT_STATIC "Compile as static library" OFF)
option(SPFFT_OMP "Compile with OpenMP support" ON)
option(SPFFT_MPI "Compile with MPI support" ON)
option(SPFFT_GPU_DIRECT "Compile with GPU direct (GPU aware MPI) support." OFF)
option(SPFFT_BUILD_TESTS "Build tests" OFF)
option(SPFFT_SINGLE_PRECISION "Enable single precision support" OFF)
option(SPFFT_INSTALL "Enable CMake install commands" ON)
option(SPFFT_FORTRAN "Compile fortran module" OFF)

set(SPFFT_GPU_BACKEND "OFF" CACHE STRING "GPU backend")
set_property(CACHE SPFFT_GPU_BACKEND PROPERTY STRINGS
	"OFF" "CUDA" "ROCM"
	)

set(SPFFT_FFTW_LIB "AUTO" CACHE STRING "Library providing a FFTW interface")
set_property(CACHE SPFFT_FFTW_LIB PROPERTY STRINGS
	"AUTO" "FFTW" "MKL" "ARMPL"
	)

# Get GNU standard install prefixes
include(GNUInstallDirs)

# set preferred library type
if (SPFFT_STATIC)
	# prefer static over dynamic libraries with the find_library() command by changing the order
	set(CMAKE_FIND_LIBRARY_SUFFIXES_SAVE ${CMAKE_FIND_LIBRARY_SUFFIXES})
	if(APPLE)
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .tbd .dylib .so)
	elseif(UNIX)
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .so)
	endif()
	set(SPFFT_LIBRARY_TYPE STATIC)
else()
	set(SPFFT_LIBRARY_TYPE SHARED)
endif()

set(SPFFT_EXTERNAL_LIBS)
set(SPFFT_INCLUDE_DIRS)
set(SPFFT_EXTERNAL_INCLUDE_DIRS)
set(SPFFT_EXTERNAL_PKG_PACKAGES)

# Options combination check
set(SPFFT_CUDA OFF)
set(SPFFT_ROCM OFF)
if(SPFFT_GPU_BACKEND)
	if(SPFFT_GPU_BACKEND STREQUAL "CUDA")
		set(SPFFT_CUDA ON)
	elseif(SPFFT_GPU_BACKEND STREQUAL "ROCM")
		set(SPFFT_ROCM ON)
	else()
		message(FATAL_ERROR "Invalid GPU backend option")
	endif()
endif()
mark_as_advanced(SPFFT_CUDA SPFFT_ROCM)

# Fortran
if(SPFFT_FORTRAN)
	enable_language(Fortran)
endif()

# CUDA
if(SPFFT_CUDA)
	enable_language(CUDA)

	if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.17.0") 
		find_package(CUDAToolkit REQUIRED)
	else()
		find_library(CUDA_CUDART_LIBRARY cudart PATHS ${CMAKE_CUDA_IMPLICIT_LINK_DIRECTORIES})
		find_library(CUDA_CUFFT_LIBRARY cufft PATHS ${CMAKE_CUDA_IMPLICIT_LINK_DIRECTORIES})
		if(NOT TARGET CUDA::cudart)
			add_library(CUDA::cudart INTERFACE IMPORTED)
		endif()
		set_property(TARGET CUDA::cudart PROPERTY INTERFACE_LINK_LIBRARIES ${CUDA_CUDART_LIBRARY})
		set_property(TARGET CUDA::cudart PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})
		if(NOT TARGET CUDA::cufft)
			add_library(CUDA::cufft INTERFACE IMPORTED)
		endif()
		set_property(TARGET CUDA::cufft PROPERTY INTERFACE_LINK_LIBRARIES ${CUDA_CUFFT_LIBRARY})
		set_property(TARGET CUDA::cufft PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})
	endif()

	list(APPEND SPFFT_EXTERNAL_LIBS CUDA::cudart CUDA::cufft)
endif()

# ROCM
if(SPFFT_ROCM)
	find_package(hip CONFIG REQUIRED)
	find_package(rocfft CONFIG REQUIRED)
	find_package(hipfft CONFIG) # hipfft within rocfft is deprecated. Use separate hipfft if available (not required).

	if(hipfft_FOUND)
		# Issue with rocm 4.1.0: Symlink to rocfft provided hipfft.h in /opt/rocm/include.
		# Workaround: Only use hipfft include directory with hipfft target and place before other hip targets in lib list
		if(HIPFFT_INCLUDE_DIRS)
			set_property(TARGET hip::hipfft PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${HIPFFT_INCLUDE_DIRS})
		endif()
		list(APPEND SPFFT_EXTERNAL_LIBS hip::hipfft)
	endif()

	list(APPEND SPFFT_EXTERNAL_LIBS hip::host roc::rocfft)

	# FindHIP module provides compilation command for GPU code
	find_package(HIP MODULE REQUIRED)
	if(NOT HIP_HCC_FLAGS)
		message(STATUS "Using default AMD gpu targets: gfx803, gfx900, gfx906. Set HIP_HCC_FLAGS to override.")
		set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} --amdgpu-target=gfx803 --amdgpu-target=gfx900 --amdgpu-target=gfx906)
	endif()
endif()

if(SPFFT_MPI)
	find_package(MPI COMPONENTS CXX REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS MPI::MPI_CXX)
endif()

if(SPFFT_OMP)
	find_package(OpenMP COMPONENTS CXX REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS OpenMP::OpenMP_CXX)
endif()

if(SPFFT_GPU_DIRECT)
	message(STATUS "GPU Direct support enabled: Additional environment variables might have to be set before execution. (e.g \"export MPICH_RDMA_ENABLED_CUDA=1\")")
endif()


# FFTW library must be found if not set to AUTO
set(_SPFFT_FIND_FFTW_LIB_OPTION)
if(NOT ${SPFFT_FFTW_LIB} STREQUAL "AUTO")
	set(_SPFFT_FIND_FFTW_LIB_OPTION REQUIRED)
endif()

set(SPFFT_MKL OFF)
set(SPFFT_ARMPL OFF)
set(SPFFT_FFTW OFF)

# Look for MKL first
if(${SPFFT_FFTW_LIB} STREQUAL "AUTO" OR ${SPFFT_FFTW_LIB} STREQUAL "MKL")
	# Use MKL if available, otherwise require FFTW3
	if(UNIX AND NOT APPLE)
		# prefer static MKL in Linux. Together with "-Wl,--exclude-libs,ALL",
		# symbols are not visible for linking afterwards and no conflicts with other MKL versions of other libraries should exist.
		set(_TMP_SAVE ${CMAKE_FIND_LIBRARY_SUFFIXES})
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .so)
	endif()
	find_package(MKLSequential ${_SPFFT_FIND_FFTW_LIB_OPTION})
	if(UNIX AND NOT APPLE)
		set(CMAKE_FIND_LIBRARY_SUFFIXES ${_TMP_SAVE})
		unset(_TMP_SAVE)
	endif()
	if(TARGET MKL::Sequential)
		list(APPEND SPFFT_EXTERNAL_LIBS MKL::Sequential)
		list(APPEND SPFFT_EXTERNAL_PKG_PACKAGES mkl-dynamic-lp64-seq)
		set(SPFFT_MKL ON)
	endif()
endif()


# Look for ARM PL
if(NOT SPFFT_MKL AND ${SPFFT_FFTW_LIB} STREQUAL "AUTO" OR ${SPFFT_FFTW_LIB} STREQUAL "ARMPL")
	find_package(ARMPL ${_SPFFT_FIND_FFTW_LIB_OPTION})
	if(TARGET ARM::pl)
		list(APPEND SPFFT_EXTERNAL_LIBS ARM::pl)
		set(SPFFT_ARMPL ON)
	endif()
endif()

# Look for FFTW library if required
if(NOT SPFFT_MKL AND NOT SPFFT_ARMPL)
	find_package(FFTW REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS FFTW::FFTW)
	if(SPFFT_SINGLE_PRECISION)
		find_package(FFTWF REQUIRED)
		list(APPEND SPFFT_EXTERNAL_LIBS FFTWF::FFTWF)
	endif()
	list(APPEND SPFFT_EXTERNAL_PKG_PACKAGES fftw3)
	set(SPFFT_FFTW ON)
endif()


# generate config.h
configure_file(include/spfft/config.h.in ${PROJECT_BINARY_DIR}/spfft/config.h)

list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src)
list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/include)
list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_BINARY_DIR})
list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/ext)

#############################################################################
# All include dirs and definitions must be set before sub-directory is added!
#############################################################################
add_subdirectory(src)

# add tests for developement
if(SPFFT_BUILD_TESTS)
	add_subdirectory(tests)
endif()

# reset cmake library suffixes
if(SPFFT_STATIC)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_FIND_LIBRARY_SUFFIXES_SAVE})
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -57,33 +57,66 @@
 	if(CMAKE_CXX_STANDARD)
 		set(HIP_HCC_FLAGS ${HIP_HCC_FLAGS} -std=gnu++${CMAKE_CXX_STANDARD})
 	endif()
-			
-	# macro from FindHIP package, which compiles all .cu files with hipcc and cpp files with the set c++ compiler
-	HIP_ADD_LIBRARY(spfft ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
-else()
-	add_library(spfft ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
 endif()
 
-set_property(TARGET spfft PROPERTY VERSION ${SPFFT_VERSION})
-set_property(TARGET spfft PROPERTY SOVERSION ${SPFFT_SO_VERSION})
-# All .cu files are self-contained. Device linking can have issues with propageted linker flags of other targets like MPI.
-if(SPFFT_CUDA)
-	set_property(TARGET spfft PROPERTY CUDA_RESOLVE_DEVICE_SYMBOLS OFF)
-	set_property(TARGET spfft PROPERTY CUDA_SEPARABLE_COMPILATION OFF)
+
+# Creates library with given name. All common target modifications should be done here.
+macro(spfft_create_library _TARGET_NAME)
+	# create target
+	if(SPFFT_ROCM)
+		# macro from FindHIP package, which compiles all .cu files with hipcc and cpp files with the set c++ compiler
+		HIP_ADD_LIBRARY(${_TARGET_NAME} ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
+	else()
+		add_library(${_TARGET_NAME} ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})
+	endif()
+
+	# set version
+	set_property(TARGET ${_TARGET_NAME} PROPERTY VERSION ${SPFFT_VERSION})
+	set_property(TARGET ${_TARGET_NAME} PROPERTY SOVERSION ${SPFFT_SO_VERSION})
+
+	# All .cu files are self-contained. Device linking can have issues with propageted linker flags of other targets like MPI.
+	if(SPFFT_CUDA)
+		set_property(TARGET ${_TARGET_NAME} PROPERTY CUDA_RESOLVE_DEVICE_SYMBOLS OFF)
+		set_property(TARGET ${_TARGET_NAME} PROPERTY CUDA_SEPARABLE_COMPILATION OFF)
+	endif()
+
+	# Don't export any symbols of external static libaries. Only works on linux.
+	if(UNIX AND NOT APPLE)
+		if(${CMAKE_VERSION} VERSION_LESS "3.13.5") 
+			target_link_libraries(${_TARGET_NAME} PRIVATE "-Wl,--exclude-libs,ALL")
+		else()
+			target_link_options(${_TARGET_NAME} PRIVATE "-Wl,--exclude-libs,ALL")
+		endif()
+	endif()
+
+	target_include_directories(${_TARGET_NAME} PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
+	target_link_libraries(${_TARGET_NAME} PRIVATE ${SPFFT_EXTERNAL_LIBS})
+
+	target_include_directories(${_TARGET_NAME} INTERFACE $<INSTALL_INTERFACE:include>) # for install(EXPORT ...)
+	target_include_directories(${_TARGET_NAME} INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>) # for export(...)
+	if(${SPFFT_FORTRAN}) # Add include directory for fortran module
+		target_include_directories(${_TARGET_NAME} INTERFACE $<INSTALL_INTERFACE:include/spfft>)
+		target_include_directories(${_TARGET_NAME} INTERFACE $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>)
+	endif()
+
+endmacro()
+
+# Create library
+spfft_create_library(spfft)
+set_target_properties(spfft PROPERTIES VISIBILITY_INLINES_HIDDEN TRUE CXX_VISIBILITY_PRESET hidden)
+
+# Create library for testing, which allows linking to internal symbols and has timings enabled.
+if(SPFFT_BUILD_TESTS)
+	spfft_create_library(spfft_test)
+	set_target_properties(spfft_test PROPERTIES VISIBILITY_INLINES_HIDDEN FALSE CXX_VISIBILITY_PRESET default)
+	target_compile_options(spfft_test PUBLIC -DSPFFT_STATIC_DEFINE) # disable properties of export header
+	# enable internal timings
+	target_compile_options(spfft_test PUBLIC -DSPFFT_TIMING)
 endif()
 
 # build fortran module
 if(SPFFT_FORTRAN)
 	add_library(spfft_fortran OBJECT ${PROJECT_SOURCE_DIR}/include/spfft/spfft.f90)
-endif()
-
-# Don't export any symbols of external static libaries. Only works on linux.
-if(UNIX AND NOT APPLE)
-	if(${CMAKE_VERSION} VERSION_LESS "3.13.5") 
-		set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--exclude-libs,ALL")
-	else()
-		target_link_options(spfft PRIVATE "-Wl,--exclude-libs,ALL")
-	endif()
 endif()
 
 # generate export header to control symbol visibility
@@ -94,27 +127,9 @@
 	COPYONLY
 )
 
-target_compile_options(spfft PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
-target_include_directories(spfft PRIVATE ${SPFFT_EXTERNAL_INCLUDE_DIRS})
-target_include_directories(spfft PRIVATE ${PROJECT_SOURCE_DIR}/include)
-target_include_directories(spfft PRIVATE ${PROJECT_SOURCE_DIR}/src)
-target_include_directories(spfft PRIVATE ${PROJECT_BINARY_DIR})
-target_link_libraries(spfft PRIVATE ${SPFFT_EXTERNAL_LIBS})
-
-target_include_directories(spfft INTERFACE ${SPFFT_INTERFACE_INCLUDE_DIRS})
-target_include_directories(spfft INTERFACE $<INSTALL_INTERFACE:include>) # for install(EXPORT ...)
-target_include_directories(spfft INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>) # for export(...)
-
-# set list of interface libries for exporting (workaround for bug with exporting static library:
-# cmake uses MPI_CXX and OpenMP::OpenMP_CXX targets, which are not known externally)
-if(POLICY CMP0022)
-	set_target_properties(spfft PROPERTIES INTERFACE_LINK_LIBRARIES "${SPFFT_INTERFACE_LIBS}")
-else()
-	set_target_properties(spfft PROPERTIES LINK_INTERFACE_LIBRARIES "${SPFFT_INTERFACE_LIBS}")
-endif()
-
 # set packge config names
-if(SPFFT_STATIC)
+get_target_property(_LIB_TYPE spfft TYPE)
+if(_LIB_TYPE STREQUAL "STATIC_LIBRARY")
 	set(SPFFT_VERSION_FILE "SpFFTStaticConfigVersion.cmake")
 	set(SPFFT_CONFIG_FILE "SpFFTStaticConfig.cmake")
 	set(SPFFT_TARGETS_FILE "SpFFTStaticTargets.cmake")
@@ -173,6 +188,10 @@
 
 	install(FILES ${PROJECT_BINARY_DIR}/SpFFT.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
+	install(DIRECTORY "${PROJECT_SOURCE_DIR}/cmake/modules"
+		DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/SpFFT"
+        FILES_MATCHING PATTERN "*.cmake")
+
 	if(SPFFT_FORTRAN)
 		install(FILES ${PROJECT_BINARY_DIR}/src/spfft.mod DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/spfft)
 	endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -66,24 +66,19 @@
 
 	# benchmark executable
 	add_executable(benchmark programs/benchmark.cpp)
-	target_link_libraries(benchmark PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
-	target_compile_options(benchmark PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
+	target_link_libraries(benchmark PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 	target_include_directories(benchmark PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
-
-	# if(SPFFT_CUDA)
-	#     set_property(TARGET main PROPERTY CUDA_SEPARABLE_COMPILATION ON)
-	# endif()
 
 	# test executables
 	add_executable(run_local_tests
 		run_local_tests.cpp
 		local_tests/test_host_array.cpp
 		local_tests/test_disjoint.cpp
+		local_tests/test_fftw_prop_hash.cpp
 		local_tests/test_local_transform.cpp
 		)
 	target_link_libraries(run_local_tests PRIVATE gtest_main gtest_mpi)
-	target_link_libraries(run_local_tests PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
-	target_compile_options(run_local_tests PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
+	target_link_libraries(run_local_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 	target_include_directories(run_local_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
 
 	if(SPFFT_MPI)
@@ -95,8 +90,7 @@
 			mpi_tests/test_transpose_gpu.cpp
 			)
 		target_link_libraries(run_mpi_tests PRIVATE gtest_main gtest_mpi)
-		target_link_libraries(run_mpi_tests PRIVATE ${SPFFT_LIBS} ${SPFFT_EXTERNAL_LIBS})
-		target_compile_options(run_mpi_tests PRIVATE ${SPFFT_DEFINITIONS} ${SPFFT_EXTERNAL_COMPILE_OPTIONS})
+		target_link_libraries(run_mpi_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 		target_include_directories(run_mpi_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
 	endif()

=== debian/changelog ===
spfft (1.0.6-1) unstable; urgency=medium

  * New upstream version 1.0.6
  * Bumping copyright years.
  * No need to forward remove-badges.patch.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.0, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Mon, 21 Feb 2022 03:58:05 -0500

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper-compat (= 13),
  libfftw3-dev,
  mpi-default-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/eth-cscs/SpFFT
 Vcs-Browser: https://salsa.debian.org/science-team/spfft

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spfft-$1.tar.gz%" \
 https://github.com/eth-cscs/SpFFT/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
